#include<bits/stdc++.h>
using namespace std;
const int maxn=1e5+5;

int afa[maxn];
int Find_fa_a(int x){ return afa[x]==x?x:afa[x]=Find_fa_a(afa[x]); }

int bfa[maxn];
int Find_fa_b(int x){ return bfa[x]==x?x:bfa[x]=Find_fa_b(bfa[x]); }

int a_sizo[maxn],a_sizz[maxn];
void Merge_a(int x,int y){
	int fx=Find_fa_a(x),fy=Find_fa_a(y);
	if(fx!=fy) afa[fy]=fx,a_sizo[fx]+=a_sizo[fy],a_sizz[fx]+=a_sizz[fy];
}

int b_sizo[maxn],b_sizz[maxn];
void Merge_b(int x,int y){
	int fx=Find_fa_b(x),fy=Find_fa_b(y);
	if(fx!=fy) bfa[fy]=fx,b_sizo[fx]+=b_sizo[fy],b_sizz[fx]+=b_sizz[fy];
}

int a[maxn],b[maxn],ta[maxn],tb[maxn];
char ch;
int main(){
	freopen("edit.in","r",stdin);
	freopen("edit.out","w",stdout);
	int t,n; scanf("%d",&t);
	while(t--){
		scanf("%d",&n);
		for(int i=1;i<=n;i++){
			cin>>ch;
			a[i]=ch-'0';
			if(a[i]) a_sizo[i]=1,a_sizz[i]=0;
			else a_sizo[i]=0,a_sizz[i]=1;
			afa[i]=i;
		}
		for(int i=1;i<=n;i++){
			cin>>ch;
			b[i]=ch-'0';
			if(b[i]) b_sizo[i]=1,b_sizz[i]=0;
			else b_sizo[i]=0,b_sizz[i]=1; 
			bfa[i]=i;
		}
		for(int i=1;i<=n;i++){
			cin>>ch;
			ta[i]=ch-'0';
		}
		for(int i=1;i<=n;i++){
			cin>>ch;
			tb[i]=ch-'0';
		}
		for(int i=1;i<=n;i++){
			if(ta[i]&&ta[i-1]) Merge_a(i-1,i);
			if(tb[i]&&tb[i-1]) Merge_b(i-1,i);
		}
		int ans=0;
		for(int i=1;i<=n;i++){
			if(!ta[i]){
				if(!tb[i]){
					if(a[i]==b[i]) ans++;
				}
				else{
					if(a[i]){
						int fx=Find_fa_b(i);
						if(b_sizo[fx]) ans++,b_sizo[fx]--;
						else b_sizz[fx]--;
					}
					else{
						int fx=Find_fa_b(i);
						if(b_sizz[fx]) ans++,b_sizz[fx]--;
						else b_sizo[fx]--;
					}
				}
			}
			else{
				if(!tb[i]){
					if(b[i]){
						int fx=Find_fa_a(i);
						if(a_sizo[fx]) ans++,a_sizo[fx]--;
						else a_sizz[fx]--;
					}
					else{
						int fx=Find_fa_a(i);
						if(a_sizz[fx]) ans++,a_sizz[fx]--;
						else a_sizo[fx]--;
					}
				}
				else{
					int fx=Find_fa_a(i),fy=Find_fa_b(i);
					if(a_sizo[fx]&&b_sizo[fy]) ans++,a_sizo[fx]--,b_sizo[fy]--;
					else if(a_sizz[fx]&&b_sizz[fy]) ans++,a_sizz[fx]--,b_sizz[fy]--;
				}
			}
		}
		printf("%d\n",ans);
	}
	return 0;
} 
